# REST система заявок

Приложение создания и обработки заявок\

В приложении два типа пользователей:\
Обычные пользователи - клиенты, создающие заявки по той или иной тематике\
Менеджеры - берут в работу и обрабатывают заявки пользователей

## Используемые технологии
- caddy web server
- php 8.2
- postgresSql
- Архитектурный подход DDD

## Способ запуска проекта

Для запуска проекта необходимо:
1. Склонировать проект
2. Обновить .env согласно .env.example
3. Собрать проект, с помощью `make up`
4. Сгенерировать ключи для JWT `make jwt-generate`
5. Установить миграции `make migrate`

## Тестовые аккаунты
Для тестирования приложения, нужно установить тестовые данные, фикстуры\
Для этого введите команду `make load-fixtures`

Фикстуры создают два аккаунта:\
Аккаунт пользователя: `test@gmail.com:password`\
Аккаунт менеджера: `testAdmin@gmail.com:password`

## Документы
- [Коллекция postman для тестирования](docs/PostmanCollection.json)
- [Дополнительные комментарии к моим решениям по коду](docs/NeBagAFicha.md)
