# Комментарии по коду 
В этом документе я описал некоторые моменты, для которых посчитал нужным написать комментарий

## Домен пользователя
- Зависимости в домене пользователя. Я оставил в домене пользователя зависимость от технологии защиты symfony, так как не вижу повода оверхедить в моменте, 
который не только полностью реализован, но и вряд ли будет когда-либо заменен
- Использование JWT UserProvider. Так же UserProvider загружает данные не из БД, а из информации в выпущенном jwt-токене. 
Это сделано в угоду оптимизации, чтобы избавиться от лишнего запроса в бд для получения роли пользователя
- Система ролей. Система ролей сильно упрощена и содержит лишь отношение 1 к 1 пользователя к роли

## Домен
- Разделение на Repository и Reader. Так как Doctrine ORM не совсем подходит для имплементации DDD, я оставил в приложении
его использование только для записи и получения сущностей там, где нужна бизнес-логика. Для чтения информации
из БД я использовал DBAL в Reader. Для чтения нам не нужно загружать в память сущности с бизнес-логикой и сложные
процессы Doctrine + представление для ответа отличается от сущностей в репозиториях, поэтому для оптимизации операции 
чтения лучше отделить от операций обновления/создания. По сути, это следование по пути CQRS =)

## Проблемы, которые есть в коде
- Зависимость домена от application. Внутри DTO я использую аттрибуты для валидации системой.
Не критичный момент, но лучше вынести такую валидацию из домена. Использовал в коде такой подход для удобства
- Так как symfony пока что не очень хорошо ладит при маппинге с enum, валидация в 
[ChangeStatusRequestDTO](../src/Domain/Request/DTO/Request/Query/ChangeStatusRequestDTO.php) захардкожена в Choice.
- Использование int для описания статуса в бд. Это не выглядит очень удобным в коде 