<?php

namespace App\Application\Controller\Request\User;

use App\Application\Services\Request\CreateUserService;
use App\Domain\Request\DTO\Request\Query\NewRequestDTO;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Component\HttpKernel\Attribute\MapRequestPayload;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Http\Attribute\IsGranted;

#[AsController]
final class CreateRequestController
{
    public function __construct(private CreateUserService $createUserService)
    {
    }

    #[Route('/api/user/requests', name: 'create_request', methods: ['POST'])]
    #[IsGranted('ROLE_USER')]
    public function __invoke(#[MapRequestPayload] NewRequestDTO $requestDTO): Response
    {
        $this->createUserService->create($requestDTO);

        return new Response(status: Response::HTTP_CREATED);
    }
}
