<?php

namespace App\Application\Security\User;

use Lexik\Bundle\JWTAuthenticationBundle\Security\User\JWTUser;

class AuthUser extends JWTUser
{
    private string $userUuid;

    public function __construct(string $userIdentifier, string $userUuid, array $roles = [])
    {
        parent::__construct($userIdentifier, $roles);
        $this->userUuid = $userUuid;
    }

    public static function createFromPayload($username, array $payload): AuthUser
    {
        return new self(
            $username,
            $payload['id'],
            $payload['roles'],
        );
    }

    /**
     * Уникальный идентификатор пользователя
     *
     * @return string
     */
    public function getUuid(): string
    {
        return $this->userUuid;
    }
}
