<?php

namespace App\Application\Services\Request;

use App\Domain\Request\DTO\Request\Query\NewRequestDTO;
use App\Domain\Request\Entity\Request;
use App\Domain\Request\Interfaces\RequestRepositoryInterface;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;

final class CreateUserService
{
    public function __construct(
        private readonly RequestRepositoryInterface $repository,
        private readonly TokenStorageInterface $tokenStorage,
    ) {
    }

    /**
     * Создать запрос
     *
     * @param NewRequestDTO $requestDTO
     * @return void
     */
    public function create(NewRequestDTO $requestDTO): void
    {
        $userId = $this->tokenStorage->getToken()->getUser()->getUuid();

        $request = Request::create($requestDTO, $userId);

        $this->repository->persist($request);
    }
}
