<?php

namespace App\Domain\Request\DTO\Request\Query;

use App\Domain\Request\Status\Status;
use Symfony\Component\Validator\Constraints as Assert;

final readonly class ChangeStatusRequestDTO
{
    public function __construct(
        #[Assert\Choice(
            choices: [Status::NEW->value, Status::IN_PROGRESS->value, Status::DONE->value],
            message: 'Невалидный статус запроса'
        )]
        public int $status,
        #[Assert\NotBlank(message: 'При изменении статуса, нужно обязательно оставить комментарий', allowNull: false)]
        public string $comment
    ) {
    }
}
