<?php

namespace App\Domain\Request\DTO\Request\Query;

use App\Domain\Request\DTO\PaginateQuery;
use Symfony\Component\Validator\Constraints as Assert;

final class GetRequestsDTO
{
    public PaginateQuery $pagination;

    // Приватные свойства добавлены для удобства маппинга к queryString
    public function __construct(
        #[Assert\Positive(message: 'Количество записей на странице должно быть положительным')]
        #[Assert\NotBlank(allowNull: true)]
        private readonly int $perPage = 10,
        #[Assert\Positive(message: 'Номер страницы должен быть положительным')]
        #[Assert\NotBlank(allowNull: true)]
        private readonly int $page = 1,
        #[Assert\NotBlank(allowNull: true)]
        public ?int $status = null,
        public string $topic = '',
        public string $userId = '',
    ) {
        $this->pagination = new PaginateQuery($perPage, $page);
    }
}
