<?php

namespace App\Domain\Request\DTO\Request\Response;

use App\Domain\Request\DTO\Request\RequestUser;
use App\Domain\Request\Status\Status;
use DateTime;

final readonly class RequestDTO
{
    public function __construct(
        public string $id,
        public string $topic,
        public string $message,
        string $userId = '',
        string $userEmail = '',
        public DateTime $createdAt = new DateTime('now'),
        public Status $status = Status::NEW,
        public string $comment = '',
    ) {
        $this->user = new RequestUser($userId, $userEmail);
    }

    public RequestUser $user;
}
