<?php

namespace App\Domain\Request\Interfaces;

use App\Domain\Request\DTO\PaginateQuery;
use App\Domain\Request\DTO\PaginationDataDTO;
use App\Domain\Request\DTO\Request\Query\GetRequestsDTO;
use App\Domain\Request\DTO\Request\Response\RequestDTO;
use App\Domain\Request\Entity\Request;

interface RequestReaderInterface
{
    /**
     * Все запросы, принадлежащие пользователю
     *
     * @param GetRequestsDTO $request
     * @return mixed
     */
    public function getRequests(GetRequestsDTO $request): PaginationDataDTO;

    /**
     * Получить заявку по идентификатору
     *
     * @param string $id
     * @param string|null $userId
     * @return RequestDTO|null
     */
    public function getRequestById(string $id, ?string $userId = null): ?RequestDTO;
}
