<?php

namespace App\Domain\Request\Interfaces;

use App\Domain\Request\DTO\PaginateQuery;
use App\Domain\Request\DTO\PaginationDataDTO;
use App\Domain\Request\DTO\Request\Query\GetRequestsDTO;
use App\Domain\Request\DTO\Request\Response\RequestDTO;
use App\Domain\Request\Entity\Request;

interface RequestRepositoryInterface
{
    /**
     * Запись состояния объекта в хранилище
     *
     * @param Request $request
     * @return void
     */
    public function persist(Request $request): void;

    /**
     * Получить Request
     *
     * @param string $id
     * @return Request|null
     */
    public function getById(string $id): ?Request;
}
