<?php

namespace App\Infrastructure\Request\Repository;

use App\Domain\Request\Entity\Request;
use App\Domain\Request\Interfaces\RequestRepositoryInterface;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\ORM\EntityRepository;

class RequestRepository implements RequestRepositoryInterface
{
    private readonly EntityRepository $repository;

    public function __construct(private readonly EntityManagerInterface $entityManager)
    {
        $this->repository = $this->entityManager->getRepository(Request::class);
    }

    /**
     * Записать сущность в таблицу
     *
     * @param Request $request
     * @return void
     */
    public function persist(Request $request): void
    {
        $this->entityManager->persist($request);

        $this->entityManager->flush();
    }

    /**
     * Поиск по идентификатору
     *
     * @param string $id
     * @return Request|null
     */
    public function getById(string $id): ?Request
    {
        return $this->repository->find($id);
    }
}
